// Generated by gencpp from file power_msgs/BreakerState.msg
// DO NOT EDIT!


#ifndef POWER_MSGS_MESSAGE_BREAKERSTATE_H
#define POWER_MSGS_MESSAGE_BREAKERSTATE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace power_msgs
{
template <class ContainerAllocator>
struct BreakerState_
{
  typedef BreakerState_<ContainerAllocator> Type;

  BreakerState_()
    : name()
    , state(0)
    , current(0.0)
    , temperature(0.0)
    , min_rated_current(0.0)
    , max_rated_current(0.0)
    , max_rated_temperature(0.0)  {
    }
  BreakerState_(const ContainerAllocator& _alloc)
    : name(_alloc)
    , state(0)
    , current(0.0)
    , temperature(0.0)
    , min_rated_current(0.0)
    , max_rated_current(0.0)
    , max_rated_temperature(0.0)  {
  (void)_alloc;
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _name_type;
  _name_type name;

   typedef uint8_t _state_type;
  _state_type state;

   typedef float _current_type;
  _current_type current;

   typedef float _temperature_type;
  _temperature_type temperature;

   typedef float _min_rated_current_type;
  _min_rated_current_type min_rated_current;

   typedef float _max_rated_current_type;
  _max_rated_current_type max_rated_current;

   typedef float _max_rated_temperature_type;
  _max_rated_temperature_type max_rated_temperature;



  enum {
    STATE_DISABLED = 0u,
    STATE_ENABLED = 1u,
    STATE_ERROR = 2u,
  };


  typedef boost::shared_ptr< ::power_msgs::BreakerState_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::power_msgs::BreakerState_<ContainerAllocator> const> ConstPtr;

}; // struct BreakerState_

typedef ::power_msgs::BreakerState_<std::allocator<void> > BreakerState;

typedef boost::shared_ptr< ::power_msgs::BreakerState > BreakerStatePtr;
typedef boost::shared_ptr< ::power_msgs::BreakerState const> BreakerStateConstPtr;

// constants requiring out of line definition

   

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::power_msgs::BreakerState_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::power_msgs::BreakerState_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace power_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/melodic/share/std_msgs/cmake/../msg'], 'power_msgs': ['/tmp/binarydeb/ros-melodic-power-msgs-0.3.0/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::power_msgs::BreakerState_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::power_msgs::BreakerState_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::power_msgs::BreakerState_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::power_msgs::BreakerState_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::power_msgs::BreakerState_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::power_msgs::BreakerState_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::power_msgs::BreakerState_<ContainerAllocator> >
{
  static const char* value()
  {
    return "e8cf206acdcddee3412681363f829642";
  }

  static const char* value(const ::power_msgs::BreakerState_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xe8cf206acdcddee3ULL;
  static const uint64_t static_value2 = 0x412681363f829642ULL;
};

template<class ContainerAllocator>
struct DataType< ::power_msgs::BreakerState_<ContainerAllocator> >
{
  static const char* value()
  {
    return "power_msgs/BreakerState";
  }

  static const char* value(const ::power_msgs::BreakerState_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::power_msgs::BreakerState_<ContainerAllocator> >
{
  static const char* value()
  {
    return "#\n\
# Gives feedback on a Breaker\n\
# Similar to REP-117, missing measurements should be denoted with a NAN\n\
#\n\
\n\
uint8 STATE_DISABLED = 0\n\
uint8 STATE_ENABLED = 1\n\
uint8 STATE_ERROR = 2\n\
\n\
# Name of the breaker\n\
string name\n\
\n\
# The state of the breaker, should be one of the values seen above.\n\
uint8 state\n\
\n\
# The current flowing through the breaker, in Amps.\n\
float32 current\n\
\n\
# The temperature of the breaker, in degrees C.\n\
float32 temperature\n\
\n\
# The rated current limits of the breaker.\n\
# Outside of these limits, breaker should trip.\n\
# If breaker cannot measure or protect against negative\n\
# current, min_rated_current should be 0.0\n\
float32 min_rated_current\n\
float32 max_rated_current\n\
\n\
# The rated temperature limit of breaker.\n\
# Above this temperature, breaker should trip.\n\
float32 max_rated_temperature\n\
";
  }

  static const char* value(const ::power_msgs::BreakerState_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::power_msgs::BreakerState_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.name);
      stream.next(m.state);
      stream.next(m.current);
      stream.next(m.temperature);
      stream.next(m.min_rated_current);
      stream.next(m.max_rated_current);
      stream.next(m.max_rated_temperature);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct BreakerState_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::power_msgs::BreakerState_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::power_msgs::BreakerState_<ContainerAllocator>& v)
  {
    s << indent << "name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.name);
    s << indent << "state: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.state);
    s << indent << "current: ";
    Printer<float>::stream(s, indent + "  ", v.current);
    s << indent << "temperature: ";
    Printer<float>::stream(s, indent + "  ", v.temperature);
    s << indent << "min_rated_current: ";
    Printer<float>::stream(s, indent + "  ", v.min_rated_current);
    s << indent << "max_rated_current: ";
    Printer<float>::stream(s, indent + "  ", v.max_rated_current);
    s << indent << "max_rated_temperature: ";
    Printer<float>::stream(s, indent + "  ", v.max_rated_temperature);
  }
};

} // namespace message_operations
} // namespace ros

#endif // POWER_MSGS_MESSAGE_BREAKERSTATE_H
