# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from power_msgs/BatteryState.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy

class BatteryState(genpy.Message):
  _md5sum = "c0df8652534c18c47b3a816b394d41e4"
  _type = "power_msgs/BatteryState"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Name of the battery
string name

# Charge level of battery as percentage of maximum charge
float32 charge_level

# If true, the battery is being charged
bool is_charging

# When charging, this is the remaining time until fully charged.
# When discharging, this is the time until battery is empty.
# Non-zero values are considered valid.
duration remaining_time

# The list of errors associated wtih the charger
string[] errors
"""
  __slots__ = ['name','charge_level','is_charging','remaining_time','errors']
  _slot_types = ['string','float32','bool','duration','string[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       name,charge_level,is_charging,remaining_time,errors

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(BatteryState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.name is None:
        self.name = ''
      if self.charge_level is None:
        self.charge_level = 0.
      if self.is_charging is None:
        self.is_charging = False
      if self.remaining_time is None:
        self.remaining_time = genpy.Duration()
      if self.errors is None:
        self.errors = []
    else:
      self.name = ''
      self.charge_level = 0.
      self.is_charging = False
      self.remaining_time = genpy.Duration()
      self.errors = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_fB2i().pack(_x.charge_level, _x.is_charging, _x.remaining_time.secs, _x.remaining_time.nsecs))
      length = len(self.errors)
      buff.write(_struct_I.pack(length))
      for val1 in self.errors:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.remaining_time is None:
        self.remaining_time = genpy.Duration()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8')
      else:
        self.name = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.charge_level, _x.is_charging, _x.remaining_time.secs, _x.remaining_time.nsecs,) = _get_struct_fB2i().unpack(str[start:end])
      self.is_charging = bool(self.is_charging)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.errors = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.errors.append(val1)
      self.remaining_time.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_fB2i().pack(_x.charge_level, _x.is_charging, _x.remaining_time.secs, _x.remaining_time.nsecs))
      length = len(self.errors)
      buff.write(_struct_I.pack(length))
      for val1 in self.errors:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.remaining_time is None:
        self.remaining_time = genpy.Duration()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8')
      else:
        self.name = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.charge_level, _x.is_charging, _x.remaining_time.secs, _x.remaining_time.nsecs,) = _get_struct_fB2i().unpack(str[start:end])
      self.is_charging = bool(self.is_charging)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.errors = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.errors.append(val1)
      self.remaining_time.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_fB2i = None
def _get_struct_fB2i():
    global _struct_fB2i
    if _struct_fB2i is None:
        _struct_fB2i = struct.Struct("<fB2i")
    return _struct_fB2i
