// Auto-generated. Do not edit!

// (in-package power_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class BatteryState {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.name = null;
      this.charge_level = null;
      this.is_charging = null;
      this.remaining_time = null;
      this.errors = null;
    }
    else {
      if (initObj.hasOwnProperty('name')) {
        this.name = initObj.name
      }
      else {
        this.name = '';
      }
      if (initObj.hasOwnProperty('charge_level')) {
        this.charge_level = initObj.charge_level
      }
      else {
        this.charge_level = 0.0;
      }
      if (initObj.hasOwnProperty('is_charging')) {
        this.is_charging = initObj.is_charging
      }
      else {
        this.is_charging = false;
      }
      if (initObj.hasOwnProperty('remaining_time')) {
        this.remaining_time = initObj.remaining_time
      }
      else {
        this.remaining_time = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('errors')) {
        this.errors = initObj.errors
      }
      else {
        this.errors = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type BatteryState
    // Serialize message field [name]
    bufferOffset = _serializer.string(obj.name, buffer, bufferOffset);
    // Serialize message field [charge_level]
    bufferOffset = _serializer.float32(obj.charge_level, buffer, bufferOffset);
    // Serialize message field [is_charging]
    bufferOffset = _serializer.bool(obj.is_charging, buffer, bufferOffset);
    // Serialize message field [remaining_time]
    bufferOffset = _serializer.duration(obj.remaining_time, buffer, bufferOffset);
    // Serialize message field [errors]
    bufferOffset = _arraySerializer.string(obj.errors, buffer, bufferOffset, null);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type BatteryState
    let len;
    let data = new BatteryState(null);
    // Deserialize message field [name]
    data.name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [charge_level]
    data.charge_level = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [is_charging]
    data.is_charging = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [remaining_time]
    data.remaining_time = _deserializer.duration(buffer, bufferOffset);
    // Deserialize message field [errors]
    data.errors = _arrayDeserializer.string(buffer, bufferOffset, null)
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.name.length;
    object.errors.forEach((val) => {
      length += 4 + val.length;
    });
    return length + 21;
  }

  static datatype() {
    // Returns string type for a message object
    return 'power_msgs/BatteryState';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'c0df8652534c18c47b3a816b394d41e4';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Name of the battery
    string name
    
    # Charge level of battery as percentage of maximum charge
    float32 charge_level
    
    # If true, the battery is being charged
    bool is_charging
    
    # When charging, this is the remaining time until fully charged.
    # When discharging, this is the time until battery is empty.
    # Non-zero values are considered valid.
    duration remaining_time
    
    # The list of errors associated wtih the charger
    string[] errors
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new BatteryState(null);
    if (msg.name !== undefined) {
      resolved.name = msg.name;
    }
    else {
      resolved.name = ''
    }

    if (msg.charge_level !== undefined) {
      resolved.charge_level = msg.charge_level;
    }
    else {
      resolved.charge_level = 0.0
    }

    if (msg.is_charging !== undefined) {
      resolved.is_charging = msg.is_charging;
    }
    else {
      resolved.is_charging = false
    }

    if (msg.remaining_time !== undefined) {
      resolved.remaining_time = msg.remaining_time;
    }
    else {
      resolved.remaining_time = {secs: 0, nsecs: 0}
    }

    if (msg.errors !== undefined) {
      resolved.errors = msg.errors;
    }
    else {
      resolved.errors = []
    }

    return resolved;
    }
};

module.exports = BatteryState;
