// Auto-generated. Do not edit!

// (in-package power_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class BreakerState {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.name = null;
      this.state = null;
      this.current = null;
      this.temperature = null;
      this.min_rated_current = null;
      this.max_rated_current = null;
      this.max_rated_temperature = null;
    }
    else {
      if (initObj.hasOwnProperty('name')) {
        this.name = initObj.name
      }
      else {
        this.name = '';
      }
      if (initObj.hasOwnProperty('state')) {
        this.state = initObj.state
      }
      else {
        this.state = 0;
      }
      if (initObj.hasOwnProperty('current')) {
        this.current = initObj.current
      }
      else {
        this.current = 0.0;
      }
      if (initObj.hasOwnProperty('temperature')) {
        this.temperature = initObj.temperature
      }
      else {
        this.temperature = 0.0;
      }
      if (initObj.hasOwnProperty('min_rated_current')) {
        this.min_rated_current = initObj.min_rated_current
      }
      else {
        this.min_rated_current = 0.0;
      }
      if (initObj.hasOwnProperty('max_rated_current')) {
        this.max_rated_current = initObj.max_rated_current
      }
      else {
        this.max_rated_current = 0.0;
      }
      if (initObj.hasOwnProperty('max_rated_temperature')) {
        this.max_rated_temperature = initObj.max_rated_temperature
      }
      else {
        this.max_rated_temperature = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type BreakerState
    // Serialize message field [name]
    bufferOffset = _serializer.string(obj.name, buffer, bufferOffset);
    // Serialize message field [state]
    bufferOffset = _serializer.uint8(obj.state, buffer, bufferOffset);
    // Serialize message field [current]
    bufferOffset = _serializer.float32(obj.current, buffer, bufferOffset);
    // Serialize message field [temperature]
    bufferOffset = _serializer.float32(obj.temperature, buffer, bufferOffset);
    // Serialize message field [min_rated_current]
    bufferOffset = _serializer.float32(obj.min_rated_current, buffer, bufferOffset);
    // Serialize message field [max_rated_current]
    bufferOffset = _serializer.float32(obj.max_rated_current, buffer, bufferOffset);
    // Serialize message field [max_rated_temperature]
    bufferOffset = _serializer.float32(obj.max_rated_temperature, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type BreakerState
    let len;
    let data = new BreakerState(null);
    // Deserialize message field [name]
    data.name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [state]
    data.state = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [current]
    data.current = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [temperature]
    data.temperature = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [min_rated_current]
    data.min_rated_current = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [max_rated_current]
    data.max_rated_current = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [max_rated_temperature]
    data.max_rated_temperature = _deserializer.float32(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.name.length;
    return length + 25;
  }

  static datatype() {
    // Returns string type for a message object
    return 'power_msgs/BreakerState';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'e8cf206acdcddee3412681363f829642';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    #
    # Gives feedback on a Breaker
    # Similar to REP-117, missing measurements should be denoted with a NAN
    #
    
    uint8 STATE_DISABLED = 0
    uint8 STATE_ENABLED = 1
    uint8 STATE_ERROR = 2
    
    # Name of the breaker
    string name
    
    # The state of the breaker, should be one of the values seen above.
    uint8 state
    
    # The current flowing through the breaker, in Amps.
    float32 current
    
    # The temperature of the breaker, in degrees C.
    float32 temperature
    
    # The rated current limits of the breaker.
    # Outside of these limits, breaker should trip.
    # If breaker cannot measure or protect against negative
    # current, min_rated_current should be 0.0
    float32 min_rated_current
    float32 max_rated_current
    
    # The rated temperature limit of breaker.
    # Above this temperature, breaker should trip.
    float32 max_rated_temperature
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new BreakerState(null);
    if (msg.name !== undefined) {
      resolved.name = msg.name;
    }
    else {
      resolved.name = ''
    }

    if (msg.state !== undefined) {
      resolved.state = msg.state;
    }
    else {
      resolved.state = 0
    }

    if (msg.current !== undefined) {
      resolved.current = msg.current;
    }
    else {
      resolved.current = 0.0
    }

    if (msg.temperature !== undefined) {
      resolved.temperature = msg.temperature;
    }
    else {
      resolved.temperature = 0.0
    }

    if (msg.min_rated_current !== undefined) {
      resolved.min_rated_current = msg.min_rated_current;
    }
    else {
      resolved.min_rated_current = 0.0
    }

    if (msg.max_rated_current !== undefined) {
      resolved.max_rated_current = msg.max_rated_current;
    }
    else {
      resolved.max_rated_current = 0.0
    }

    if (msg.max_rated_temperature !== undefined) {
      resolved.max_rated_temperature = msg.max_rated_temperature;
    }
    else {
      resolved.max_rated_temperature = 0.0
    }

    return resolved;
    }
};

// Constants for message
BreakerState.Constants = {
  STATE_DISABLED: 0,
  STATE_ENABLED: 1,
  STATE_ERROR: 2,
}

module.exports = BreakerState;
